package de.steamwar.lobby.particle.particles;

import de.steamwar.lobby.particle.ParticleData;
import de.steamwar.lobby.particle.ParticleEnum;
import de.steamwar.lobby.particle.elements.DustParticle;
import de.steamwar.lobby.particle.elements.LocationMutator;
import de.steamwar.lobby.particle.elements.SimpleParticle;
import lombok.AllArgsConstructor;
import lombok.Getter;
import org.bukkit.Material;
import org.bukkit.Particle;

@AllArgsConstructor
public enum PlayerParticle implements ParticleEnum {

    SNEEZE(new ParticleData(Material.SLIME_BLOCK, "PARTICLE_SNEEZE",
            new SimpleParticle(Particle.SNEEZE, 0.2F, 0.2F, 0.2F, 0.01))
    ),
    SMOKE(new ParticleData(Material.COBWEB, "PARTICLE_SMOKE",
            new SimpleParticle(Particle.SMOKE_NORMAL, 0.2F, 0.2F, 0.2F, 0.01))
    ),
    FIRE(new ParticleData(Material.LAVA_BUCKET, "PARTICLE_FIRE",
            new SimpleParticle(Particle.DRIP_LAVA))
    ),
    WATER(new ParticleData(Material.WATER_BUCKET, "PARTICLE_WATER",
            new SimpleParticle(Particle.DRIP_WATER))
    ),
    HEARTH(new ParticleData(Material.RED_DYE, "PARTICLE_HEART",
            new LocationMutator(new SimpleParticle(Particle.HEART), 0, 2.2, 0))
    ),
    NOTES(new ParticleData(Material.NOTE_BLOCK, "PARTICLE_NOTES",
            new LocationMutator(new SimpleParticle(Particle.NOTE), 0, 2.2, 0))
    ),
    NAUTILUS(new ParticleData(Material.NAUTILUS_SHELL, "PARTICLE_NAUTILUS",
            new SimpleParticle(Particle.NAUTILUS, 0.2F, 0.2F ,0.2F, 0.01))
    ),
    SNOWBALL(new ParticleData(Material.SNOWBALL, "PARTICLE_SNOWBALL",
            new SimpleParticle(Particle.SNOWBALL, 0.2F, 0.2F ,0.2F, 0.01))
    ),
    EFFECT(new ParticleData(Material.GLASS_BOTTLE, "PARTICLE_EFFECT",
            new DustParticle(Particle.REDSTONE, 0, 0.2F, 0, 0.01, 5, null))
    ),
    CAMPFIRE(new ParticleData(Material.CAMPFIRE, "PARTICLE_CAMPFIRE",
            new SimpleParticle(Particle.CAMPFIRE_COSY_SMOKE, 0, 0.2F ,0, 0.01))
    ),
    MAGIC(new ParticleData(Material.CAULDRON, "PARTICLE_MAGIC",
            new SimpleParticle(Particle.CRIT_MAGIC, 0.2F, 0.2F, 0.2F, 0.01))
    ),
    ANGRY(new ParticleData(Material.REDSTONE_BLOCK, "PARTICLE_ANGRY",
            new SimpleParticle(Particle.VILLAGER_ANGRY, 0.2F, 0.2F, 0.2F, 0.01))
    ),
    SLIME(new ParticleData(Material.SLIME_BALL, "PARTICLE_SLIME",
            new SimpleParticle(Particle.SLIME))
    ),
    MOB(new ParticleData(Material.ZOMBIE_HEAD, "PARTICLE_MOB",
            new SimpleParticle(Particle.SPELL_MOB))
    ),
    ;
    public static ParticleEnum[] particles = values();

    @Getter
    private ParticleData particle;
}
